g.enableRecomputeMonitor = () => Sdk.Send('SetFlags("recompute");\n');

g.showDebugConsole = () => g.log(`
<input type="button" value="Enable recompute monitor" onClick="g.enableRecomputeMonitor()">
<input type="button" value="Enable echo" onClick="Sdk.EnableEcho()">
<input type="button" value="Disable echo" onClick="Sdk.DisableEcho()">
<input type="button" value="Disable follow" onClick="follow=false">
<input type="button" value="Enable follow" onClick="follow=true">
<input type="button" value="Go to" onClick="Sdk.Position.SetPosition(document.getElementById('golat').value, document.getElementById('golon').value)"> latitude:<input id="golat" type="text" size="8" value="48.14816"> longitude:<input id="golon" type="text" size="8" value="17.10674">
<input type="button" value="Go to" onClick="Sdk.Position.SetPosition(document.getElementById('golx').value/100000, document.getElementById('goly').value/100000)"> lX:<input id="golx" type="text" size="8" value="4814816"> lY:<input id="goly" type="text" size="8" value="1710674">
<input type="button" value="Go to" onClick="Sdk.Position.SetPosition(document.getElementById('golalo').value.split(',')[0], document.getElementById('golalo').value.split(',')[1])"> la,lo:<input id="golalo" type="text" size="22" value="45.2947323,-75.728894">
<input type="button" value="Toggle noise" onClick="noise=!noise">
<input type="button" value="Start demonstration" onClick="Sdk.Demonstrate.Start()"> <input type="button" value="Stop demonstration" onClick="Sdk.Demonstrate.Stop()"> <input type="button" value="1x" onClick="Sdk.Demonstrate.SetSpeed(100)"> <input type="button" value="4x" onClick="Sdk.Demonstrate.SetSpeed(400)"> <input type="button" value="32x" onClick="Sdk.Demonstrate.SetSpeed(3200)">
<input type="button" value="Get roads" onClick="_getRoads()">
<input type="button" value="Get junctions" onClick="_getJunctions()">
<input type="button" value="Quick route" onClick="_quickRoute(document.getElementById('quickroute').value)"> <input id="quickroute" type="text" size="40" value="45.29764,-75.73085 ; 45.29312,-75.72394">
<input type="button" value="Get map list" onClick="_getMapList()">
<input type="text" id="command"><input type="button" value="Send" size="20" onClick="Sdk.Send(document.getElementById('command').value + ';\\n')">
<input type="button" value="Set traffic zoom level" onClick="g.SetTrafficLevel();">
`);

g.SetTrafficLevel = () =>
{                           
  Sdk.Skin.Get("traffic", "lodShowAll")
  .then( l => console.log("Previous traffic level = "+l))
  .then( () => Sdk.MapView.GetRealLevel() )
  .then( (l) => {console.log("Level = "+l); Sdk.Skin.Set("traffic", "lodShowAll", l); } )
  .then( () => Sdk.Skin.Get("traffic", "lodShowAll") )
  .then( l => console.log("New traffic level = "+l))
  .then( () => Sdk.Skin.Reload() );
}

g.popup = (origin, target) =>
{
    var cmdTraffic = "Sdk.Traffic.Add("+target.lat.toFixed(5)+", "+target.lng.toFixed(5)+").then( (geom) => onTraffic(geom) );";
    var cmdScout = "Sdk.Route.Info(["+
     "{lat:"+origin.lat.toFixed(6)+", lng:"+origin.lng.toFixed(6) + "}," + 
     "{lat:"+target.lat.toFixed(6)+", lng:"+target.lng.toFixed(6)+ "}]);";
    var cmdCalculate = "Sdk.Route.Set(["+
     "{lat:"+origin.lat.toFixed(6)+", lng:"+origin.lng.toFixed(6) + "}," + 
     "{lat:"+target.lat.toFixed(6)+", lng:"+target.lng.toFixed(6)+ "}]);";
    var cmdDebugConsole = "g.showDebugConsole();";
    var cmdOffline = ""; //"Sdk.Route.SetAlternatives(false); Sdk.Route.SetService('offline');"
    var cmdOnline = "Sdk.Route.SetAlternatives(false); Sdk.Route.SetService('online');"

    // hide popup
    cmdTraffic += "this.parentNode.parentNode.previousSibling.click();";
    cmdScout += "this.parentNode.parentNode.previousSibling.click();";
    cmdCalculate += "this.parentNode.parentNode.previousSibling.click();";
    cmdDebugConsole += "this.parentNode.parentNode.previousSibling.click();";
    return '<a href="#" onClick="'+cmdTraffic+'">Add traffic</a><br>'+
      '<a href="#" onClick="'+cmdOffline + cmdCalculate+'">Calculate offline route</a><br>'+
//      '<a href="#" onClick="'+cmdOnline + cmdCalculate+'">Calculate online route</a><br>'+
//      '<a href="#" onClick="'+cmdScout+'">Calculate scout</a><br>'+
      '<a href="#" onClick="'+cmdDebugConsole+'">Show debug console</a>';
}